<template>
  <a :href="'/products/' + product.id">
    <a-card hoverable>
      <img
        slot="cover"
        alt=""
        :src="imageUrl"
      />
      <a-alert v-if="product.inStock <= 0" type="error" banner class="badge" message="Ausverkauft"></a-alert>
      <a-alert v-else-if="product.inStock <= 10" banner class="badge" message="Wenige verfügbar"></a-alert>

      <a-row>
        <a-col :sm="16" :xs="24">
          <p class="ant-card-meta-title">{{ product.name }}</p>
          <p class="ant-card-meta-description">{{ product.description }}</p>
        </a-col>
        <a-col :sm="8" :xs="24">
          <a-statistic :precision="2" :value="product.price" suffix="€"></a-statistic>
        </a-col>
      </a-row>
    </a-card>
  </a>
</template>
<script lang="ts">
import Vue, { PropType } from 'vue'
import { Product } from '~/types/types.ts'

export default Vue.extend({
  name: 'product-card',
  props: {
    product: {
      type: Object as PropType<Product>,
      required: true
    }
  },
  computed: {
    imageUrl (): string {
      if (this.product.images.length === 0) {
        return '/placeholder.png'
      }
      if (this.product.images[0].url.startsWith('http')) {
        return this.product.images[0].url
      }
      return process.env.strapiBaseUri + this.product.images[0].url
    }
  }
})
</script>
<style lang="scss" scoped>
img {
  width: 100%;
  height: 400px;
  object-fit: cover;
  z-index: 0;
}

.badge {
  position: absolute;
  top: 0;
  right: 0;
  border-bottom-left-radius: 20px;
}
</style>
